/* (c) https://github.com/MontiCore/monticore */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: simulationController.proto

package protobuf;

/**
 * Protobuf type {@code SimulationController.PlannedTrajectory}
 */
public  final class PlannedTrajectory extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:SimulationController.PlannedTrajectory)
    PlannedTrajectoryOrBuilder {
private static final long serialVersionUID = 0L;
  // Use PlannedTrajectory.newBuilder() to construct.
  private PlannedTrajectory(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private PlannedTrajectory() {
    osmID_ = "";
    posX_ = 0F;
    posY_ = 0F;
    posZ_ = 0F;
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return this.unknownFields;
  }
  private PlannedTrajectory(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    if (extensionRegistry == null) {
      throw new java.lang.NullPointerException();
    }
    int mutable_bitField0_ = 0;
    com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          default: {
            if (!parseUnknownFieldProto3(
                input, unknownFields, extensionRegistry, tag)) {
              done = true;
            }
            break;
          }
          case 10: {
            java.lang.String s = input.readStringRequireUtf8();

            osmID_ = s;
            break;
          }
          case 21: {

            posX_ = input.readFloat();
            break;
          }
          case 29: {

            posY_ = input.readFloat();
            break;
          }
          case 37: {

            posZ_ = input.readFloat();
            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return protobuf.SimulationControllerProto.internal_static_SimulationController_PlannedTrajectory_descriptor;
  }

  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return protobuf.SimulationControllerProto.internal_static_SimulationController_PlannedTrajectory_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            protobuf.PlannedTrajectory.class, protobuf.PlannedTrajectory.Builder.class);
  }

  public static final int OSMID_FIELD_NUMBER = 1;
  private volatile java.lang.Object osmID_;
  /**
   * <code>string osmID = 1;</code>
   */
  public java.lang.String getOsmID() {
    java.lang.Object ref = osmID_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      osmID_ = s;
      return s;
    }
  }
  /**
   * <code>string osmID = 1;</code>
   */
  public com.google.protobuf.ByteString
      getOsmIDBytes() {
    java.lang.Object ref = osmID_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      osmID_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int POSX_FIELD_NUMBER = 2;
  private float posX_;
  /**
   * <code>float posX = 2;</code>
   */
  public float getPosX() {
    return posX_;
  }

  public static final int POSY_FIELD_NUMBER = 3;
  private float posY_;
  /**
   * <code>float posY = 3;</code>
   */
  public float getPosY() {
    return posY_;
  }

  public static final int POSZ_FIELD_NUMBER = 4;
  private float posZ_;
  /**
   * <code>float posZ = 4;</code>
   */
  public float getPosZ() {
    return posZ_;
  }

  private byte memoizedIsInitialized = -1;
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (!getOsmIDBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 1, osmID_);
    }
    if (posX_ != 0F) {
      output.writeFloat(2, posX_);
    }
    if (posY_ != 0F) {
      output.writeFloat(3, posY_);
    }
    if (posZ_ != 0F) {
      output.writeFloat(4, posZ_);
    }
    unknownFields.writeTo(output);
  }

  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (!getOsmIDBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, osmID_);
    }
    if (posX_ != 0F) {
      size += com.google.protobuf.CodedOutputStream
        .computeFloatSize(2, posX_);
    }
    if (posY_ != 0F) {
      size += com.google.protobuf.CodedOutputStream
        .computeFloatSize(3, posY_);
    }
    if (posZ_ != 0F) {
      size += com.google.protobuf.CodedOutputStream
        .computeFloatSize(4, posZ_);
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof protobuf.PlannedTrajectory)) {
      return super.equals(obj);
    }
    protobuf.PlannedTrajectory other = (protobuf.PlannedTrajectory) obj;

    boolean result = true;
    result = result && getOsmID()
        .equals(other.getOsmID());
    result = result && (
        java.lang.Float.floatToIntBits(getPosX())
        == java.lang.Float.floatToIntBits(
            other.getPosX()));
    result = result && (
        java.lang.Float.floatToIntBits(getPosY())
        == java.lang.Float.floatToIntBits(
            other.getPosY()));
    result = result && (
        java.lang.Float.floatToIntBits(getPosZ())
        == java.lang.Float.floatToIntBits(
            other.getPosZ()));
    result = result && unknownFields.equals(other.unknownFields);
    return result;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    hash = (37 * hash) + OSMID_FIELD_NUMBER;
    hash = (53 * hash) + getOsmID().hashCode();
    hash = (37 * hash) + POSX_FIELD_NUMBER;
    hash = (53 * hash) + java.lang.Float.floatToIntBits(
        getPosX());
    hash = (37 * hash) + POSY_FIELD_NUMBER;
    hash = (53 * hash) + java.lang.Float.floatToIntBits(
        getPosY());
    hash = (37 * hash) + POSZ_FIELD_NUMBER;
    hash = (53 * hash) + java.lang.Float.floatToIntBits(
        getPosZ());
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static protobuf.PlannedTrajectory parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static protobuf.PlannedTrajectory parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static protobuf.PlannedTrajectory parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static protobuf.PlannedTrajectory parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static protobuf.PlannedTrajectory parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static protobuf.PlannedTrajectory parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static protobuf.PlannedTrajectory parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static protobuf.PlannedTrajectory parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static protobuf.PlannedTrajectory parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static protobuf.PlannedTrajectory parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static protobuf.PlannedTrajectory parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static protobuf.PlannedTrajectory parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(protobuf.PlannedTrajectory prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * Protobuf type {@code SimulationController.PlannedTrajectory}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:SimulationController.PlannedTrajectory)
      protobuf.PlannedTrajectoryOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return protobuf.SimulationControllerProto.internal_static_SimulationController_PlannedTrajectory_descriptor;
    }

    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return protobuf.SimulationControllerProto.internal_static_SimulationController_PlannedTrajectory_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              protobuf.PlannedTrajectory.class, protobuf.PlannedTrajectory.Builder.class);
    }

    // Construct using protobuf.PlannedTrajectory.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessageV3
              .alwaysUseFieldBuilders) {
      }
    }
    public Builder clear() {
      super.clear();
      osmID_ = "";

      posX_ = 0F;

      posY_ = 0F;

      posZ_ = 0F;

      return this;
    }

    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return protobuf.SimulationControllerProto.internal_static_SimulationController_PlannedTrajectory_descriptor;
    }

    public protobuf.PlannedTrajectory getDefaultInstanceForType() {
      return protobuf.PlannedTrajectory.getDefaultInstance();
    }

    public protobuf.PlannedTrajectory build() {
      protobuf.PlannedTrajectory result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    public protobuf.PlannedTrajectory buildPartial() {
      protobuf.PlannedTrajectory result = new protobuf.PlannedTrajectory(this);
      result.osmID_ = osmID_;
      result.posX_ = posX_;
      result.posY_ = posY_;
      result.posZ_ = posZ_;
      onBuilt();
      return result;
    }

    public Builder clone() {
      return (Builder) super.clone();
    }
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.setField(field, value);
    }
    public Builder clearField(
        com.google.protobuf.Descriptors.FieldDescriptor field) {
      return (Builder) super.clearField(field);
    }
    public Builder clearOneof(
        com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return (Builder) super.clearOneof(oneof);
    }
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        int index, java.lang.Object value) {
      return (Builder) super.setRepeatedField(field, index, value);
    }
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.addRepeatedField(field, value);
    }
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof protobuf.PlannedTrajectory) {
        return mergeFrom((protobuf.PlannedTrajectory)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(protobuf.PlannedTrajectory other) {
      if (other == protobuf.PlannedTrajectory.getDefaultInstance()) return this;
      if (!other.getOsmID().isEmpty()) {
        osmID_ = other.osmID_;
        onChanged();
      }
      if (other.getPosX() != 0F) {
        setPosX(other.getPosX());
      }
      if (other.getPosY() != 0F) {
        setPosY(other.getPosY());
      }
      if (other.getPosZ() != 0F) {
        setPosZ(other.getPosZ());
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    public final boolean isInitialized() {
      return true;
    }

    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      protobuf.PlannedTrajectory parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (protobuf.PlannedTrajectory) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }

    private java.lang.Object osmID_ = "";
    /**
     * <code>string osmID = 1;</code>
     */
    public java.lang.String getOsmID() {
      java.lang.Object ref = osmID_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        osmID_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>string osmID = 1;</code>
     */
    public com.google.protobuf.ByteString
        getOsmIDBytes() {
      java.lang.Object ref = osmID_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        osmID_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>string osmID = 1;</code>
     */
    public Builder setOsmID(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      osmID_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>string osmID = 1;</code>
     */
    public Builder clearOsmID() {
      
      osmID_ = getDefaultInstance().getOsmID();
      onChanged();
      return this;
    }
    /**
     * <code>string osmID = 1;</code>
     */
    public Builder setOsmIDBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      osmID_ = value;
      onChanged();
      return this;
    }

    private float posX_ ;
    /**
     * <code>float posX = 2;</code>
     */
    public float getPosX() {
      return posX_;
    }
    /**
     * <code>float posX = 2;</code>
     */
    public Builder setPosX(float value) {
      
      posX_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>float posX = 2;</code>
     */
    public Builder clearPosX() {
      
      posX_ = 0F;
      onChanged();
      return this;
    }

    private float posY_ ;
    /**
     * <code>float posY = 3;</code>
     */
    public float getPosY() {
      return posY_;
    }
    /**
     * <code>float posY = 3;</code>
     */
    public Builder setPosY(float value) {
      
      posY_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>float posY = 3;</code>
     */
    public Builder clearPosY() {
      
      posY_ = 0F;
      onChanged();
      return this;
    }

    private float posZ_ ;
    /**
     * <code>float posZ = 4;</code>
     */
    public float getPosZ() {
      return posZ_;
    }
    /**
     * <code>float posZ = 4;</code>
     */
    public Builder setPosZ(float value) {
      
      posZ_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>float posZ = 4;</code>
     */
    public Builder clearPosZ() {
      
      posZ_ = 0F;
      onChanged();
      return this;
    }
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFieldsProto3(unknownFields);
    }

    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:SimulationController.PlannedTrajectory)
  }

  // @@protoc_insertion_point(class_scope:SimulationController.PlannedTrajectory)
  private static final protobuf.PlannedTrajectory DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new protobuf.PlannedTrajectory();
  }

  public static protobuf.PlannedTrajectory getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<PlannedTrajectory>
      PARSER = new com.google.protobuf.AbstractParser<PlannedTrajectory>() {
    public PlannedTrajectory parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return new PlannedTrajectory(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<PlannedTrajectory> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<PlannedTrajectory> getParserForType() {
    return PARSER;
  }

  public protobuf.PlannedTrajectory getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

